/////////////////////////////////////////////////////////////////////////////
//
//  Code emprunte (mais je n'envisage pas de le rendre ;-)  
// 
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
/////////////////////////////////////////////////////////////////////////////


#define	SOCKET_ERRNO	errno
#define	ERRNO		errno


#include <sys/socket.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <net/if.h>
#include <net/pfvar.h>
#include <netdb.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "dockapp.h"

static struct sockaddr TcpFormatAdress( char * host, u_short port )
{
    struct sockaddr_in addr;
    struct sockaddr addrRet;
    struct hostent *lphost ; 
    u_long IP;
    
    
    memset((char*)&addr, 0, sizeof(addr));
    /*	Soit on fournit une adresse IP, soit on fournit un nom	*/
    if ((IP = inet_addr(host)) == (u_long)INADDR_NONE)
    {
      if ((lphost  =  gethostbyname(host))==NULL)
	{
            memset( (char * )&addrRet, 0, sizeof(addrRet) );
	    return  addrRet;
	}
	addr.sin_family = lphost->h_addrtype;
	memcpy (&addr.sin_addr, lphost->h_addr, lphost->h_length);

    }
    else
    {
        addr.sin_family = AF_INET;
        addr.sin_addr.s_addr = IP;
    }
    
    /*  Port destination    */    
    addr.sin_port = htons((u_short)port );    
    
    memcpy( (char *)&addrRet, (char *)&addr, sizeof(addrRet) );
    return addrRet;
}

int get_mbmon( int nPort, double *tcpu, int *vsys, int *vcpu )
    {
    int hSocket;
    struct sockaddr_in addr; 
    struct sockaddr addrConnect;
    int cb;
    char BufRecv[1024];
    char * pszHost = "127.0.0.1";

    

    /* socket TCP */
    hSocket = socket( PF_INET, SOCK_STREAM, 0 );
    if( hSocket == -1)
    {
      return (False);
    }

    /*  bind */
    addr.sin_family = AF_INET ;
    addr.sin_addr.s_addr = htonl (INADDR_ANY);
    addr.sin_port = htons ((unsigned short)0 );
    if ( bind( hSocket, (struct sockaddr *)&addr, sizeof(addr)) == -1 )
    {

      return (False);
    }


    /* Transform the host/port into a struct sockaddr*/
    addrConnect = TcpFormatAdress( pszHost, (u_short)nPort );

    /*  blocking mode  */
    if( connect( hSocket, &addrConnect, sizeof(addrConnect) ) == -1)
    {
      return (False);
    }

    cb = recv( hSocket, BufRecv, sizeof(BufRecv), 0 );
    {
      char *ap, *bf =BufRecv ;
      while ( (ap = strsep(&bf,"\n")) != NULL) {
	if (!strncmp(ap,"TEMP1",5))
	  (*  tcpu) =  strtod((const char *)(strrchr(ap,(int)' ')+1), NULL);
	if (!strncmp(ap,"FAN1",4))
	  (* vcpu )= atoi((const char *)(strrchr(ap,(int)' ')+1));
	if (!strncmp(ap,"FAN0",4))
	  (* vsys)=atoi((const char *)(strrchr(ap,(int)' ')+1));
      }

    }
    close( hSocket );
    return (True);
}
